unit FBase;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ComCtrls, StdCtrls,
  ExtCtrls, ActnList, Menus, StdActns, XMLPropStorage, ValEdit, IpHtml;

type

  { TFormBase }

  TFormBase = class(TForm)
    ActionListBase: TActionList;
    actTestBase: TAction;
    actHelp: THelpAction;
    actFileExit: TFileExit;
    grdMainEigenschaften: TValueListEditor;

    MainMenuBase: TMainMenu;
    miEigenschaften: TMenuItem;
    miTest: TMenuItem;
    miTestBase: TMenuItem;
    miDatei: TMenuItem;
    miHilfe: TMenuItem;
    miDateiBeenden: TMenuItem;

    pagMain: TPageControl;
    tabMainHilfe: TTabSheet;
    pnlHTMLHilfe: TIpHtmlPanel;
    spltMain: TSplitter;
    memNachricht: TMemo;
    barStatus: TStatusBar;
    iniXML: TXMLPropStorage;
    tabEigenschaften: TTabSheet;

    procedure actHelpExecute(Sender: TObject);
    procedure actTestBaseExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure miEigenschaftenClick(Sender: TObject);
  private

  public
    FZeitFormat : string;
    procedure Nachricht(const pcsText: string);
    procedure Nachricht(const pcsFormat: string; const pac: array of const);
    procedure Nachricht(const pcsText: string; const E: Exception);
    procedure Nachricht(const pcsFormat: string; const pac: array of const; const E: Exception);

  end;

var
  FormBase: TFormBase;

implementation

uses StrUtils, UHtmlTools;

{$R *.lfm}
{$R __PROJRESOURCES__.rc}

{ TFormBase }

const
  SELF_TOP = 'SELF_TOP';
  SELF_LEFT = 'SELF_LEFT';
  SELF_HEIGHT = 'SELF_HEIGHT';
  SELF_WIDTH = 'SELF_WIDTH';

procedure TFormBase.FormCreate(Sender: TObject);
//var lvs: string;
var lvsIniDir, lvsIniFileName: string;//\AppData\Local\AM
begin
  FZeitFormat := 'hh:nn:ss >';
  //lvs := LoadTextFromRessource('HILFE');
  //FillHTML(pnlHTMLHilfe, lvs);
  //Nachricht(lvs);
  FillHTML(pnlHTMLHilfe, LoadTextFromRessource('HILFE'));
  lvsIniDir := GetUserDir()+'AppData\Local\AM\';
  lvsIniFileName := ExtractFileName(Application.ExeName);
  lvsIniFileName := LeftStr(lvsIniFileName, length(lvsIniFileName) - length(ExtractFileExt(lvsIniFileName)));
  iniXML.FileName := lvsIniDir + lvsIniFileName+'.ini';
  ForceDirectories(lvsIniDir);
  grdMainEigenschaften.InsertRow('Ini- Datei',iniXML.FileName,True);
  self.Top := iniXML.ReadInteger(SELF_TOP, self.Top);
  self.Left := iniXML.ReadInteger(SELF_LEFT, self.Left);
  self.Height := iniXML.ReadInteger(SELF_HEIGHT, self.Height);
  self.Width := iniXML.ReadInteger(SELF_WIDTH, self.Width);
end;

procedure TFormBase.FormDestroy(Sender: TObject);
begin
  try
    iniXML.WriteInteger(SELF_TOP, self.Top);
    iniXML.WriteInteger(SELF_LEFT, self.Left);
    iniXML.WriteInteger(SELF_HEIGHT, self.Height);
    iniXML.WriteInteger(SELF_WIDTH, self.Width);
  except
  end;
end;

procedure TFormBase.miEigenschaftenClick(Sender: TObject);
begin
  miEigenschaften.Checked := not miEigenschaften.Checked;
  tabEigenschaften.TabVisible := miEigenschaften.Checked;
  if tabEigenschaften.TabVisible then pagMain.ActivePage := tabEigenschaften;
end;

procedure TFormBase.actTestBaseExecute(Sender: TObject);
var
  lvn : Extended;
  lvHTML : THTML_AM;
  lvnR, lvnG, lvnB, lvnSize, i:integer;
  lvsText, lvsZeichen, lvsMehrereZeichen : string;
begin
  Nachricht('');
  Nachricht('Hallo');
  Nachricht('Hallo %s',['Welt']);
  try
    lvn := 0;
    lvn := 1 / lvn;
    Nachricht('Division durch 0 ergibt : %d',[lvn])
  except on E: Exception do begin
    Nachricht('Fehler', E);
    Nachricht('Fehler %s',['hier'], E);
    end;
  end;
  //LoadHTMLFile(pnlHTMLHilfe, 'Hilfe.html');
  lvsText := 'AbCdEfGhIjKlMnO';
  lvHTML := THTML_AM.create();
  try
    lvsMehrereZeichen := '';
    for i := 1 to length(lvsText) do begin
      lvnR := 20+i*15;lvnG:= I*2;lvnB := 255-i*5;
      lvnSize := i + 5;
      lvsZeichen := lvHTML.HTMLFont(lvsText[i], lvnR, lvnG, lvnB, lvnSize);
      lvsMehrereZeichen := lvsMehrereZeichen + lvsZeichen;
      Nachricht('%s (%d/%d/%d)',[lvsZeichen,lvnR, lvnG, lvnB]);
      //lvHTML.Append(lvsZeichen);
    end;
    lvsZeichen := lvHTML.HTML_Kapsel(lvsMehrereZeichen,'I',[]);
    lvHTML.Append(lvsZeichen);
    FillHTML(pnlHTMLHilfe, lvHTML.to_string());
  finally
  FreeAndNil(lvHTML);
  end;
end;

procedure TFormBase.actHelpExecute(Sender: TObject);
begin
  FillHTML(pnlHTMLHilfe, EntEumeln(LoadTextFromRessource('HILFE'), True));
  pagMain.ActivePage := tabMainHilfe;
end;

procedure TFormBase.Nachricht(const pcsText: string);
begin Nachricht(pcsText, [], NIL);end;

procedure TFormBase.Nachricht(const pcsFormat: string; const pac: array of const);
begin Nachricht(pcsFormat, pac, NIL);end;

procedure TFormBase.Nachricht(const pcsText: string; const E: Exception);
begin Nachricht(pcsText, [], E);end;

procedure TFormBase.Nachricht(const pcsFormat: string; const pac: array of const; const E: Exception);
var
  lvsZeit, lvsZeitLeer, lvs: string;
  lavs : TStringList;
  lvbZeitAngezeigt : boolean;
  i : integer;
begin
  lavs := TStringList.Create;
  try
    if length(pac)>0 then begin
      try
        lvs := Format(pcsFormat, pac);
      except
        lvs := pcsFormat;
      end;
    end
      else lvs := pcsFormat;
    if Assigned(E) then
      lvs := lvs+#13#10+Format('[%s]'#13#10'%s',[E.ClassName, E.Message]);
    lvsZeit := FormatDateTime(FZeitFormat,Now());
    lvsZeitLeer := DupeString(' ', Length(lvsZeit));
    lvbZeitAngezeigt := False;
    lavs.Text := lvs;
    for i := 0 to lavs.Count-1 do begin
      lvs := trim(lavs[i]);
      if lvs > '' then begin
        if lvbZeitAngezeigt then memNachricht.Append(lvsZeitLeer + lvs)
        else begin
          memNachricht.Append(lvsZeit + lvs);
          lvbZeitAngezeigt := True;
        end;
      end;
    end;
    if not lvbZeitAngezeigt then memNachricht.Append(lvsZeit);

  finally
    FreeAndNil(lavs);
  end;
end;

end.

